%module positions

%{
#include "libharkio3.h"
#include "libharkio3_macros.h"
#define HARKIO_LOG_INITIAL_LEVEL harkio_Log_Error

%}

/*! @struct harkio_Positions
 *  @brief 位置の集合を表す構造体。
 */
typedef struct{
    int size;               /*!< 構造体が保持する pos の長さ */
    int frame;              /*!< この構造体が対応するフレーム番号 */
    char *type;             /*!< この構造体のタイプを表す文字列 */
    harkio_Position **pos;  /*!< この構造体が保持する位置の配列 */
} harkio_Positions;


%extend harkio_Positions {
    char *__str__(){
        return harkio_Positions_printBuffer($self);
    }
    int __len__(){
        return $self->size;
    }
};


harkio_Positions* harkio_Positions_new(char *type, int frame, int size, harkio_Position **pos);
harkio_Positions* harkio_Positions_newFromXMLbuffer(char *buffer, int len, char *dtdpath);
void harkio_Positions_delete(harkio_Positions **pos);
void harkio_Positions_print(harkio_Positions* pos);
harkio_Positions* harkio_Positions_copy(harkio_Positions* pos);
int harkio_Positions_append(harkio_Positions *poses, harkio_Position *pos);
int harkio_Positions_removeById(harkio_Positions *poses, int id);
int harkio_Positions_removeByCoord(harkio_Positions *poses, enum Coordinate sys, float *coord, float tolerance);
harkio_Position* harkio_Positions_getById(harkio_Positions *poses, int id);
harkio_Position* harkio_Positions_getByCoord(harkio_Positions *poses, enum Coordinate sys, float *coord, float tolerance);
char*  harkio_Positions_getType(harkio_Positions *poses);
int harkio_Positions_isEqual(harkio_Positions *a, harkio_Positions *b);
int  harkio_Positions_getSize(harkio_Positions *poses);
